/*
  This file is part of shuJIT,
  Just In Time compiler for Sun Java Virtual Machine.

  Copyright (C) 1996,1997,1998,1999,2000 Kazuyuki Shudo

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

  $Id$
*/

//
// Internal Opcodes
//
#define	opc_methodhead	230	// 0xe6
#define opc_start	231
#define opc_end		232
#define	opc_epilogue	233
#define	opc_exc_handler	234
#define	opc_methodtail	235
#define	opc_sync_obj_enter	236
#define	opc_sync_obj_exit	237
#define	opc_sync_static_enter	238
#define	opc_sync_static_exit	239

#define opc_inv_head	240	// 0xf0
#define opc_invoke_core	241
#define opc_invoke_core_compiled	242
#define opc_inv_metavm	243

#define opc_inv_vir_obj		244	// 0xf4
#define opc_inv_vir_varspace	245
#define opc_invokevirtual_obj	246

#define opc_inv_spe_obj		247
#define opc_inv_spe_varspace	248

#define opc_inv_stq_obj		249
#define opc_inv_stq_varspace	250

#define	opc_invokeignored_static	251	// 0xfb
#define	opc_invokeignored_static_quick	252

#define opc_exc_check	253

// 254 and 255 are reserved for VM specific instructions
#define	opc_impdep1	254	// 0xfe
#define	opc_impdep2	255	// 0xff

#define	opc_fill_cache	256	// 0x100
#define	opc_flush_cache	257
#define	opc_array_check	258

#define	opc_throw_illegalaccess	259
#define	opc_throw_noclassdef	260

#define	opc_strict_enter	261
#define	opc_strict_exit		262

#define	opc_fld4	263	// 0x107
#define	opc_fld		264
#define	opc_fst		265
#define	opc_dld8	266
#define	opc_dld		267
#define	opc_dst		268

#define	opc_fppc_save		269	// 0x10d
#define	opc_fppc_restore	270
#define	opc_fppc_single		271
#define	opc_fppc_double		272
#define	opc_fppc_extended	273

#define	opc_strict_fprep	274	// 0x112
#define	opc_strict_fscdown	275
#define	opc_strict_fscup	276
#define	opc_strict_fsettle	277
#define	opc_strict_dprep	278
#define	opc_strict_dscdown	279
#define	opc_strict_dscup	280
#define	opc_strict_dsettle	281

#define	opc_getstatic2	282	// 0x11a
#define	opc_putstatic2	283
#define	opc_getfield2	284
#define	opc_putfield2	285

#define	opc_iastore1	286	// 0x11e
#define	opc_lastore1	287

#define	opc_stateto0	288	// 0x120
#define	opc_stateto1	289
#define	opc_stateto2	290
#define	opc_stateto3	291
#define	opc_stateto4	292

#define	opc_goto_st0	293	// 0x125
#define	opc_goto_st1	294
#define	opc_goto_st2	295
#define	opc_goto_st3	296
#define	opc_goto_st4	297

#define	opc_sqrt	298	// 0x12a
#define	opc_sin		299
#define	opc_cos		300
#define	opc_tan		301
#define	opc_atan2	302
#define	opc_atan	303	// 0x12f
#define	opc_exp		304
#define	opc_log		305
#define	opc_floor	306
#define	opc_ceil	307

// for OPTIMIZE_INTERNAL_CODE
#define	opc_fload_fld	308	// 0x134
#define opc_dload_dld	309
#define	opc_faload_fld	310
#define	opc_daload_dld	311

#define opc_fst_fstore	312
#define opc_dst_dstore	313
#define opc_fst_fastore	314
#define opc_dst_dastore	315

#define opc_istld	316	// 0x13c
#define opc_lstld	317

#define opc_invoke_recursive	318
#define opc_invoke_recursive_1	319
#define opc_invoke_recursive_2	320
#define opc_invoke_recursive_3	321

// for method inlining
#define opc_inlined_enter	322	// 0x142
#define opc_inlined_exit	323

// for MetaVM
#define opc_metavm_init	324

#define	NOPCODES	325
